about summary refs log tree commit homepage
path: root/t/test-lib.sh
diff options
context:
space:
mode:
authorEric Wong <normalperson@yhbt.net>2009-11-07 08:08:18 +0000
committerEric Wong <normalperson@yhbt.net>2009-11-07 00:09:41 -0800
commitb36235131e0b5517fc5070c02c72be01c4b7f1f9 (patch)
tree3c4774be5d51c905dcf9384c4ba5bc7816e7905d /t/test-lib.sh
parent1a9a718a3f9a5b582a4a339a9bb9249c2ca392d7 (diff)
downloadrainbows-b36235131e0b5517fc5070c02c72be01c4b7f1f9.tar.gz
sha1sum(1) is only common GNU systems, and it may be installed
as gsha1sum on *BSDs.  We'll also try using the openssl sha1
implementation, too.  And finally, we'll provide our own Ruby
sha1sum.rb implementation as a last resort.

We go to great lengths to avoid our own Ruby version because we
want to avoid putting too much trust in ourselves, our Ruby
skills, and even the Ruby implementations.  This is especially
with regard to our knowledge and correct usage of Ruby 1.9
encoding support.  It would actually be *easier* to only use
sha1sum.rb and call it a day.  We just choose to support
SHA1 implementations provided by third parties if possible.

Performance is not a factor since sha1sum.rb performance is very
close to the C implementations.
Diffstat (limited to 't/test-lib.sh')
-rw-r--r--t/test-lib.sh10
1 files changed, 10 insertions, 0 deletions
diff --git a/t/test-lib.sh b/t/test-lib.sh
index 9e67d1d..d28eaa0 100644
--- a/t/test-lib.sh
+++ b/t/test-lib.sh
@@ -134,6 +134,16 @@ rainbows_wait_start () {
         rainbows_pid=$(cat $pid)
 }
 
+rsha1 () {
+        _cmd="$(which sha1sum 2>/dev/null || :)"
+        test -n "$_cmd" || _cmd="$(which openssl 2>/dev/null || :) sha1"
+        test "$_cmd" != " sha1" || _cmd="$(which gsha1sum 2>/dev/null || :)"
+
+        # last resort, see comments in sha1sum.rb for reasoning
+        test -n "$_cmd" || _cmd=sha1sum.rb
+        expr "$($_cmd < random_blob)" : '\([a-f0-9]\{40\}\)'
+}
+
 case $model in
 Rev) require_check rev Rev::VERSION ;;
 Revactor) require_check revactor Revactor::VERSION ;;